namespace StateMachine.Model
{
    public class Order
    {
        public OrderState State { get; private set; }

        public Order()
        {
            State = OrderState.New;
        }

        public void ProcessOrder()
        {
            switch (State)
            {
                case OrderState.New:
                    State = OrderState.Processing;
                    System.Console.WriteLine("Order is being processed.");
                    break;
                case OrderState.Processing:
                    State = OrderState.Shipped;
                    System.Console.WriteLine("Order has been shipped.");
                    break;
                case OrderState.Shipped:
                    State = OrderState.Delivered;
                    System.Console.WriteLine("Order has been delivered.");
                    break;
                default:
                System.Console.WriteLine("Invalid state transition.");
                    break;
            }
        }

        public void CancelOrder()
        {
            if (State != OrderState.Delivered && State != OrderState.Canceled)
            {
                State = OrderState.Canceled;
                System.Console.WriteLine("Order has been canceled.");
            }
            else
            {
                System.Console.WriteLine("Unable to cancel order in this state.");
            }
        }
    }
}